Validation

Bootstrap Validation

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

Provide valuable, actionable feedback to your users with HTML5 form validation – available in all our supported browsers. Choose from the browser default validation feedback, or implement custom messages with our built-in classes and starter JavaScript.

Note: For advanced users we recommend using custom validation described in this tutorial because styles as native browser defaults are not announced to screen readers.


How it works

Here’s how form validation works with Bootstrap:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <input>, <select>, and <textarea> elements.
  • Bootstrap scopes the :invalid and :valid styles to their parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid when a page is loaded. This way, you may choose when to activate them (typically after the form submission is attempted).
  • To reset the appearance of the form (for instance, in the case of dynamic form submissions using AJAX), remove the .was-validated class from the <form> again after submission.
  • As a fallback, .is-invalid and .is-valid classes may be used instead of the pseudo-classes for server-side validation. They do not require a .was-validated parent class.
  • Due to constraints in how CSS works, we cannot (at present) apply styles to a <label> that comes before a form control in the DOM without the use of custom JavaScript.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles with additional HTML and CSS.
  • You may provide custom validity messages with setCustomValidity() in JavaScript.

With that in mind, examine the following demos for our custom form validation styles, optional server-side classes, and browser defaults.


Custom styles

For custom Bootstrap form validation messages, you’ll need to add the novalidate boolean attribute to your <form>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript. Try to submit the form below; our JavaScript will intercept the submit button and relay feedback to you.

When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Default styles

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            

            <form class="needs-validation" novalidate>
              <div class="form-row">
                <div class="col-md-4 mb-3">
                  <label for="validationCustom01">First name</label>
                  <input type="text" class="form-control" id="validationCustom01" placeholder="First name" value="Mark"
                    required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationCustom02">Last name</label>
                  <input type="text" class="form-control" id="validationCustom02" placeholder="Last name" value="Otto"
                    required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationCustomUsername">Username</label>
                  <div class="input-group">
                    <div class="input-group-prepend">
                      <span class="input-group-text" id="inputGroupPrepend">@</span>
                    </div>
                    <input type="text" class="form-control" id="validationCustomUsername" placeholder="Username"
                      aria-describedby="inputGroupPrepend" required>
                    <div class="invalid-feedback">
                      Please choose a username.
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3">
                  <label for="validationCustom03">City</label>
                  <input type="text" class="form-control" id="validationCustom03" placeholder="City" required>
                  <div class="invalid-feedback">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationCustom04">State</label>
                  <input type="text" class="form-control" id="validationCustom04" placeholder="State" required>
                  <div class="invalid-feedback">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationCustom05">Zip</label>
                  <input type="text" class="form-control" id="validationCustom05" placeholder="Zip" required>
                  <div class="invalid-feedback">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-check">
                  <input class="form-check-input" type="checkbox" value="" id="invalidCheck" required>
                  <label class="form-check-label" for="invalidCheck">
                    Agree to terms and conditions
                  </label>
                  <div class="invalid-feedback">
                    You must agree before submitting.
                  </div>
                </div>
              </div>
              <button class="btn btn-primary btn-sm" type="submit">Submit form</button>
            </form>

          
        
    
        
            

              (function () {
                  'use strict';
                  window.addEventListener('load', function () {
                    // Fetch all the forms we want to apply custom Bootstrap validation styles to
                    var forms = document.getElementsByClassName('needs-validation');
                    // Loop over them and prevent submission
                    var validation = Array.prototype.filter.call(forms, function (form) {
                      form.addEventListener('submit', function (event) {
                        if (form.checkValidity() === false) {
                          event.preventDefault();
                          event.stopPropagation();
                        }
                        form.classList.add('was-validated');
                      }, false);
                    });
                  }, false);
                })();

          
        
    

Material styles MDB Pro component

Looks good!
Looks good!
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            

            <form class="needs-validation" novalidate>
              <div class="form-row">
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationCustom012">First name</label>
                  <input type="text" class="form-control" id="validationCustom012" placeholder="First name" value="Mark"
                    required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationCustom022">Last name</label>
                  <input type="text" class="form-control" id="validationCustom022" value="Otto" required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationCustomUsername2">Username</label>
                  <input type="text" class="form-control" id="validationCustomUsername2" aria-describedby="inputGroupPrepend2"
                    required>
                  <div class="invalid-feedback">
                    Please choose a username.
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3 md-form">
                  <label for="validationCustom032">City</label>
                  <input type="text" class="form-control" id="validationCustom032" required>
                  <div class="invalid-feedback">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationCustom042">State</label>
                  <input type="text" class="form-control" id="validationCustom042" required>
                  <div class="invalid-feedback">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationCustom052">Zip</label>
                  <input type="text" class="form-control" id="validationCustom052" required>
                  <div class="invalid-feedback">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-check pl-0">
                  <input class="form-check-input" type="checkbox" value="" id="invalidCheck2" required>
                  <label class="form-check-label" for="invalidCheck2">
                    Agree to terms and conditions
                  </label>
                  <div class="invalid-feedback">
                    You must agree before submitting.
                  </div>
                </div>
              </div>
              <button class="btn btn-primary btn-sm btn-rounded" type="submit">Submit form</button>
            </form>

          
        
    
        
            

              (function () {
                  'use strict';
                  window.addEventListener('load', function () {
                    // Fetch all the forms we want to apply custom Bootstrap validation styles to
                    var forms = document.getElementsByClassName('needs-validation');
                    // Loop over them and prevent submission
                    var validation = Array.prototype.filter.call(forms, function (form) {
                      form.addEventListener('submit', function (event) {
                        if (form.checkValidity() === false) {
                          event.preventDefault();
                          event.stopPropagation();
                        }
                        form.classList.add('was-validated');
                      }, false);
                    });
                  }, false);
                })();

          
        
    

Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? That's fine, you can use the browser defaults. Try submitting the form below. Depending on your browser and OS, you’ll see a slightly different style of feedback.

While these feedback styles cannot be styled with CSS, you can still customize the feedback text through JavaScript.

Default styles

@
        
            

            <form>
              <div class="form-row">
                <div class="col-md-4 mb-3">
                  <label for="validationDefault01">First name</label>
                  <input type="text" class="form-control" id="validationDefault01" placeholder="First name" value="Mark"
                    required>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationDefault02">Last name</label>
                  <input type="text" class="form-control" id="validationDefault02" placeholder="Last name" value="Otto"
                    required>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationDefaultUsername">Username</label>
                  <div class="input-group">
                    <div class="input-group-prepend">
                      <span class="input-group-text" id="inputGroupPrepend21">@</span>
                    </div>
                    <input type="text" class="form-control" id="validationDefaultUsername" placeholder="Username"
                      aria-describedby="inputGroupPrepend21" required>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3">
                  <label for="validationDefault03">City</label>
                  <input type="text" class="form-control" id="validationDefault03" placeholder="City" required>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationDefault04">State</label>
                  <input type="text" class="form-control" id="validationDefault04" placeholder="State" required>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationDefault05">Zip</label>
                  <input type="text" class="form-control" id="validationDefault05" placeholder="Zip" required>
                </div>
              </div>
              <div class="form-group">
                <div class="custom-control custom-checkbox">
                  <input type="checkbox" class="custom-control-input" id="invalidCheck12" required>
                  <label class="custom-control-label" for="invalidCheck">Agree to terms and conditions</label>
                </div>
              </div>
              <button class="btn btn-primary btn-sm" type="submit">Submit form</button>
            </form>

          
        
    

Material stylesMDB Pro component

        
            


            <form>
              <div class="form-row">
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationDefault22">First name</label>
                  <input type="text" class="form-control" id="validationDefault22" value="Mark" required>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationDefault22">Last name</label>
                  <input type="text" class="form-control" id="validationDefault22" value="Otto" required>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationDefaultUsername22">Username</label>
                  <input type="text" class="form-control" id="validationDefaultUsername22" aria-describedby="inputGroupPrepend23"
                    required>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3 md-form">
                  <label for="validationDefault22">City</label>
                  <input type="text" class="form-control" id="validationDefault22" required>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationDefault22">State</label>
                  <input type="text" class="form-control" id="validationDefault22" required>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationDefault22">Zip</label>
                  <input type="text" class="form-control" id="validationDefault22" required>
                </div>
              </div>
              <div class="form-group">
                <div class="form-check pl-0">
                  <input class="form-check-input" type="checkbox" value="" id="invalidCheck222" required>
                  <label class="form-check-label" for="invalidCheck222">
                    Agree to terms and conditions
                  </label>
                </div>
              </div>
              <button class="btn btn-primary btn-sm" type="submit">Submit form</button>
            </form>
          
        
    

Server side

We recommend using client-side validation, but in case you require server side, you can indicate invalid and valid form fields with .is-invalid and .is-valid. Note that .invalid-feedback is also supported by these classes.

Default styles

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
You must agree before submitting.
        
            

            <form>
              <div class="form-row">
                <div class="col-md-4 mb-3">
                  <label for="validationServer013">First name</label>
                  <input type="text" class="form-control is-valid" id="validationServer013" placeholder="First name"
                    value="Mark" required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationServer023">Last name</label>
                  <input type="text" class="form-control is-valid" id="validationServer023" placeholder="Last name"
                    value="Otto" required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationServerUsername33">Username</label>
                  <div class="input-group">
                    <div class="input-group-prepend">
                      <span class="input-group-text" id="inputGroupPrepend33">@</span>
                    </div>
                    <input type="text" class="form-control is-invalid" id="validationServerUsername33" placeholder="Username"
                      aria-describedby="inputGroupPrepend33" required>
                    <div class="invalid-feedback">
                      Please choose a username.
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3">
                  <label for="validationServer033">City</label>
                  <input type="text" class="form-control is-invalid" id="validationServer033" placeholder="City"
                    required>
                  <div class="invalid-feedback">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationServer043">State</label>
                  <input type="text" class="form-control is-invalid" id="validationServer043" placeholder="State"
                    required>
                  <div class="invalid-feedback">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationServer053">Zip</label>
                  <input type="text" class="form-control is-invalid" id="validationServer053" placeholder="Zip"
                    required>
                  <div class="invalid-feedback">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="custom-control custom-checkbox">
                  <input type="checkbox" class="custom-control-input is-invalid" id="invalidCheck33" required>
                  <label class="custom-control-label" for="invalidCheck33">Agree to terms and conditions</label>
                  <div class="invalid-feedback">
                    You must agree before submitting.
                  </div>
                </div>
                <div class="invalid-feedback">
                  You must agree before submitting.
                </div>
              </div>
              <button class="btn btn-primary btn-sm" type="submit">Submit form</button>
            </form>

          
        
    

Material styles

Looks good!
Looks good!
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            

            <form>
              <div class="form-row">
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationServer015">First name</label>
                  <input type="text" class="form-control is-valid" id="validationServer015" value="Mark" required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationServer025">Last name</label>
                  <input type="text" class="form-control is-valid" id="validationServer025" value="Otto" required>
                  <div class="valid-feedback">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationServerUsername55">Username</label>
                  <input type="text" class="form-control is-invalid" id="validationServerUsername55" required>
                  <div class="invalid-feedback">
                    Please choose a username.
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3 md-form">
                  <label for="validationServer035">City</label>
                  <input type="text" class="form-control is-invalid" id="validationServer035" required>
                  <div class="invalid-feedback">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationServer045">State</label>
                  <input type="text" class="form-control is-invalid" id="validationServer045" required>
                  <div class="invalid-feedback">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationServer055">Zip</label>
                  <input type="text" class="form-control is-invalid" id="validationServer055" required>
                  <div class="invalid-feedback">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-check pl-0 md-form m-0">
                  <input class="form-check-input is-invalid" type="checkbox" value="" id="invalidCheck35" required>
                  <label class="form-check-label" for="invalidCheck35">
                    Agree to terms and conditions
                  </label>
                </div>
                <div class="invalid-feedback mt-3 ml-4">
                  You must agree before submitting.
                </div>
              </div>
              <button class="btn btn-primary btn-sm btn-rounded" type="submit">Submit form</button>
            </form>


          
        
    

Supported elements

Our example forms show native textual <input>s above, but form validation styles are available for our custom form controls, as well.

Default styles

Example invalid feedback text
More example invalid feedback text
Example invalid custom select feedback
Example invalid custom file feedback
        
            

            <form class="was-validated">
              <div class="custom-control custom-checkbox mb-3">
                <input type="checkbox" class="custom-control-input" id="customControlValidation1" required>
                <label class="custom-control-label" for="customControlValidation1">Check this custom checkbox</label>
                <div class="invalid-feedback">Example invalid feedback text</div>
              </div>

              <div class="custom-control custom-radio">
                <input type="radio" class="custom-control-input" id="customControlValidation2" name="radio-stacked"
                  required>
                <label class="custom-control-label" for="customControlValidation2">Toggle this custom radio</label>
              </div>
              <div class="custom-control custom-radio mb-3">
                <input type="radio" class="custom-control-input" id="customControlValidation3" name="radio-stacked"
                  required>
                <label class="custom-control-label" for="customControlValidation3">Or toggle this other custom radio</label>
                <div class="invalid-feedback">More example invalid feedback text</div>
              </div>

              <div class="form-group">
                <select class="custom-select browser-default" required>
                  <option value="">Open this select menu</option>
                  <option value="1">One</option>
                  <option value="2">Two</option>
                  <option value="3">Three</option>
                </select>
                <div class="invalid-feedback">Example invalid custom select feedback</div>
              </div>

              <div class="custom-file">
                <input type="file" class="custom-file-input" id="validatedCustomFile" required>
                <label class="custom-file-label" for="validatedCustomFile">Choose file...</label>
                <div class="invalid-feedback">Example invalid custom file feedback</div>
              </div>
            </form>

          
        
    

Material styles MDB Pro component

Example invalid feedback text
More example invalid feedback text
Choose file
Example invalid custom file feedback
        
            

            <form class="was-validated">
              <div class="custom-control custom-checkbox mb-3">
                <input type="checkbox" class="custom-control-input" id="customControlValidation1" required>
                <label class="custom-control-label" for="customControlValidation1">Check this custom checkbox</label>
                <div class="invalid-feedback">Example invalid feedback text</div>
              </div>

              <div class="custom-control custom-radio">
                <input type="radio" class="custom-control-input" id="customControlValidation2" name="radio-stacked"
                  required>
                <label class="custom-control-label" for="customControlValidation2">Toggle this custom radio</label>
              </div>
              <div class="custom-control custom-radio mb-3">
                <input type="radio" class="custom-control-input" id="customControlValidation3" name="radio-stacked"
                  required>
                <label class="custom-control-label" for="customControlValidation3">Or toggle this other custom radio</label>
                <div class="invalid-feedback">More example invalid feedback text</div>
              </div>

              <div class="form-group">
                <select class="custom-select browser-default" required>
                  <option value="">Open this select menu</option>
                  <option value="1">One</option>
                  <option value="2">Two</option>
                  <option value="3">Three</option>
                </select>
                <div class="invalid-feedback">Example invalid custom select feedback</div>
              </div>

              <div class="custom-file">
                <input type="file" class="custom-file-input" id="validatedCustomFile" required>
                <label class="custom-file-label" for="validatedCustomFile">Choose file...</label>
                <div class="invalid-feedback">Example invalid custom file feedback</div>
              </div>
            </form>

          
        
    

Tooltips

If your form layout allows it, you can swap the .{valid|invalid}-feedback classes for .{valid|invalid}-tooltip classes to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative to it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Default styles

Looks good!
Looks good!
@
Please choose a unique and valid username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
        
            

            <form class="needs-validation" novalidate>
              <div class="form-row">
                <div class="col-md-4 mb-3">
                  <label for="validationTooltip01">First name</label>
                  <input type="text" class="form-control" id="validationTooltip01" placeholder="First name" value="Mark"
                    required>
                  <div class="valid-tooltip">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationTooltip02">Last name</label>
                  <input type="text" class="form-control" id="validationTooltip02" placeholder="Last name" value="Otto"
                    required>
                  <div class="valid-tooltip">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3">
                  <label for="validationTooltipUsername">Username</label>
                  <div class="input-group">
                    <div class="input-group-prepend">
                      <span class="input-group-text" id="validationTooltipUsernamePrepend">@</span>
                    </div>
                    <input type="text" class="form-control" id="validationTooltipUsername" placeholder="Username"
                      aria-describedby="validationTooltipUsernamePrepend" required>
                    <div class="invalid-tooltip">
                      Please choose a unique and valid username.
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3">
                  <label for="validationTooltip03">City</label>
                  <input type="text" class="form-control" id="validationTooltip03" placeholder="City" required>
                  <div class="invalid-tooltip">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationTooltip04">State</label>
                  <input type="text" class="form-control" id="validationTooltip04" placeholder="State" required>
                  <div class="invalid-tooltip">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3">
                  <label for="validationTooltip05">Zip</label>
                  <input type="text" class="form-control" id="validationTooltip05" placeholder="Zip" required>
                  <div class="invalid-tooltip">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <button class="btn btn-primary btn-sm" type="submit">Submit form</button>
            </form>

          
        
    
        
            

            // Tooltips Initialization
            $(function () {
              $('[data-toggle="tooltip"]').tooltip()
            })

          
        
    

Material styles MDB Pro component

Looks good!
Looks good!
Please choose a unique and valid username.>
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
        
            

            <form class="needs-validation" novalidate>
              <div class="form-row">
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationTooltip011">First name</label>
                  <input type="text" class="form-control" id="validationTooltip011" value="Mark" required>
                  <div class="valid-tooltip">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationTooltip021">Last name</label>
                  <input type="text" class="form-control" id="validationTooltip021" value="Otto" required>
                  <div class="valid-tooltip">
                    Looks good!
                  </div>
                </div>
                <div class="col-md-4 mb-3 md-form">
                  <label for="validationTooltipUsername1">Username</label>
                  <input type="text" class="form-control" id="validationTooltipUsername1" required>
                  <div class="invalid-tooltip">
                    Please choose a unique and valid username.>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6 mb-3 md-form">
                  <label for="validationTooltip031">City</label>
                  <input type="text" class="form-control" id="validationTooltip031" required>
                  <div class="invalid-tooltip">
                    Please provide a valid city.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationTooltip041">State</label>
                  <input type="text" class="form-control" id="validationTooltip041" required>
                  <div class="invalid-tooltip">
                    Please provide a valid state.
                  </div>
                </div>
                <div class="col-md-3 mb-3 md-form">
                  <label for="validationTooltip051">Zip</label>
                  <input type="text" class="form-control" id="validationTooltip051" required>
                  <div class="invalid-tooltip">
                    Please provide a valid zip.
                  </div>
                </div>
              </div>
              <button class="btn btn-primary btn-sm btn-rounded" type="submit">Submit form</button>
            </form>

          
        
    
        
            

            // Tooltips Initialization
            $(function () {
              $('[data-toggle="tooltip"]').tooltip()
            })

          
        
    

DatePicker Validation MDB Pro component"

Please select a valid date.
You shall not pass!
        
            

        <form class="needs-validation container" novalidate>
          <div class="mb-3 md-form">
            <input type="text" name="date" id="date" class="form-control datepicker" value="" required />
            <label for="date">Date</label>
            <div class="invalid-feedback">Please select a valid date.</div>
          </div>

          <div class="form-row my-4">
            <div class="form-check pl-0">
              <input class="form-check-input" type="checkbox" value="" id="invalidCheck266" required>
              <label class="form-check-label" for="invalidCheck266">Agree to terms and conditions</label>
              <div class="invalid-feedback">You shall not pass!</div>
            </div>
          </div>
          <button class="btn btn-primary btn-sm btn-rounded" type="submit">Submit form</button>
        </form>
      
        
    
        
            

          (function () {
              'use strict';
              window.addEventListener('load', function () {
                // Fetch all the forms we want to apply custom Bootstrap validation styles to
                var forms = document.getElementsByClassName('needs-validation');
                // Loop over them and prevent submission
                var validation = Array.prototype.filter.call(forms, function (form) {
                  form.addEventListener('submit', function (event) {
                    if (form.checkValidity() === false) {
                      event.preventDefault();
                      event.stopPropagation();
                    }
                    form.classList.add('was-validated');
                  }, false);
                });
              }, false);
            })();

            $(document).ready(function () {
              $('.datepicker').pickadate();
              $('.datepicker').removeAttr('readonly');
            });

      
        
    

Material Select Validation MDB Pro component"

Please select a country.
You shall not pass!
        
            

        <form class="needs-validation container" novalidate>
          <div class="form-row">
            <div class="mb-3 md-form">
              <select class="mdb-select" required>
                <option value="1">USA</option>
                <option value="2">Germany</option>
                <option value="3">Poland</option>
              </select>
              <div class="invalid-feedback">Please select a country.</div>
            </div>
          </div>
          <div class="form-row mb-4">
            <div class="form-check pl-0">
              <input class="form-check-input" type="checkbox" value="" id="invalidCheck29" required>
              <label class="form-check-label" for="invalidCheck29">Agree to terms and conditions</label>
              <div class="invalid-feedback">You shall not pass!</div>
            </div>
          </div>
          <button class="btn btn-primary btn-sm btn-rounded" type="submit">Submit form</button>
        </form>
      
        
    
        
            

          (function () {
              'use strict';
              window.addEventListener('load', function () {
                // Fetch all the forms we want to apply custom Bootstrap validation styles to
                var forms = document.getElementsByClassName('needs-validation');
                // Loop over them and prevent submission
                var validation = Array.prototype.filter.call(forms, function (form) {
                  form.addEventListener('submit', function (event) {
                    if (form.checkValidity() === false) {
                      event.preventDefault();
                      event.stopPropagation();
                    }
                    form.classList.add('was-validated');
                  }, false);
                });
              }, false);
            })();

            $(document).ready(function () {
              $('.mdb-select').materialSelect();
              $('.mdb-select.select-wrapper .select-dropdown').val("").removeAttr('readonly').attr("placeholder",
                "Choose your country ").prop('required', true).addClass('form-control').css('background-color', '#fff');
            });

React Bootstrap Validation

React Validation - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap Validation provide valuable, actionable feedback to your users with HTML5 form validation – available in all our supported browsers. Choose from the browser default validation feedback, or implement custom messages with our built-in classes and starter JavaScript.

Warning

We highly recommend custom validation styles as native browser defaults are not announced to screen readers.


Custom styles

For custom Bootstrap form validation messages, you’ll need to add the noValidate boolean attribute to your <form>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript.

When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Default styles

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += " was-validated";
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form
                    className="needs-validation"
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterNameEx"
                          className="grey-text"
                        >
                          First name
                        </label>
                        <input
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterNameEx"
                          className="form-control"
                          placeholder="First name"
                          required
                        />
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterEmailEx2"
                          className="grey-text"
                        >
                          Last name
                        </label>
                        <input
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterEmailEx2"
                          className="form-control"
                          placeholder="Last name"
                          required
                        />
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterConfirmEx3"
                          className="grey-text"
                        >
                          Email
                        </label>
                        <input
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="defaultFormRegisterConfirmEx3"
                          className="form-control"
                          name="email"
                          placeholder="Your Email address"
                        />
                        <small id="emailHelp" className="form-text text-muted">
                          We'll never share your email with anyone else.
                        </small>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          City
                        </label>
                        <input
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="city"
                          placeholder="City"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid city.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          State
                        </label>
                        <input
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="state"
                          placeholder="State"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid state.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          Zip
                        </label>
                        <input
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="zip"
                          placeholder="Zip"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid zip.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                    </MDBRow>
                    <MDBCol md="4" className="mb-3">
                      <div className="custom-control custom-checkbox pl-3">
                        <input
                          className="custom-control-input"
                          type="checkbox"
                          value=""
                          id="invalidCheck"
                          required
                        />
                        <label className="custom-control-label" htmlFor="invalidCheck">
                          Agree to terms and conditions
                        </label>
                        <div className="invalid-feedback">
                          You must agree before submitting.
                        </div>
                      </div>
                    </MDBCol>
                    <MDBBtn color="primary" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Material styles MDB Pro component

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += " was-validated";
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form
                    className="needs-validation"
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterNameEx"
                          label="First name"
                          required
                        >
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterEmailEx2"
                          label="Last name"
                          required
                        >
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="materialFormRegisterConfirmEx3"
                          name="email"
                          label="Your Email address"
                        >
                          <small id="emailHelp" className="form-text text-muted">
                            We'll never share your email with anyone else.
                          </small>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="city"
                          label="City"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid city.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="state"
                          label="State"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid state.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="zip"
                          label="Zip"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid zip.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBInput
                        type="checkbox"
                        value="conditions"
                        id="materialInvalidCheck"
                        required
                        label="Agree to terms and conditions"
                      >
                        <div className="invalid-feedback">
                          You must agree before submitting.
                        </div>
                      </MDBInput>
                    </MDBRow>
                    <MDBBtn color="success" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? All good, you can use the browser defaults. Depending on your browser and OS, you’ll see a slightly different style of feedback.

Default styles

        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterNameEx"
                          className="grey-text"
                        >
                          First name
                        </label>
                        <input
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterNameEx"
                          className="form-control"
                          placeholder="First name"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterEmailEx2"
                          className="grey-text"
                        >
                          Last name
                        </label>
                        <input
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterEmailEx2"
                          className="form-control"
                          placeholder="Last name"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterConfirmEx3"
                          className="grey-text"
                        >
                          Email
                        </label>
                        <input
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="defaultFormRegisterConfirmEx3"
                          className="form-control"
                          name="email"
                          placeholder="Your Email address"
                        />
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          City
                        </label>
                        <input
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="city"
                          placeholder="City"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          State
                        </label>
                        <input
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="state"
                          placeholder="State"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          Zip
                        </label>
                        <input
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="zip"
                          placeholder="Zip"
                          required
                        />
                      </MDBCol>
                    </MDBRow>
                    <MDBCol md="4" className="mb-3">
                      <div className="custom-control custom-checkbox pl-3">
                        <input
                          className="custom-control-input"
                          type="checkbox"
                          value=""
                          id="invalidCheck"
                          required
                        />
                        <label className="custom-control-label" htmlFor="invalidCheck">
                          Agree to terms and conditions
                        </label>
                      </div>
                    </MDBCol>
                    <MDBBtn color="primary" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Material styles MDB Pro component

        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterNameEx"
                          label="First name"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterEmailEx2"
                          label="Last name"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="materialFormRegisterConfirmEx3"
                          name="email"
                          label="Your Email address"
                        />
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="city"
                          label="City"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="state"
                          label="State"
                          required
                        />
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="zip"
                          label="Zip"
                          required
                        />
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBInput
                        type="checkbox"
                        value="conditions"
                        id="materialInvalidCheck"
                        required
                        label="Agree to terms and conditions"
                      />
                    </MDBRow>
                    <MDBBtn color="success" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Server side

We recommend using client side validation, but in case you require server side, you can indicate invalid and valid form fields with .is-invalid and .is-valid classes.

Default styles

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: {
                value: "Mark",
                valid: true
              },
              lname: {
                value: "Otto",
                valid: true
              },
              email: {
                value: "",
                valid: false
              },
              city: {
                value: "",
                valid: false
              },
              state: {
                value: "",
                valid: false
              },
              zip: {
                value: "",
                valid: false
              }
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: { value: event.target.value, valid: !!event.target.value } });
            };

            render() {
              return (
                <div>
                  <form>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterNameEx"
                          className="grey-text"
                        >
                          First name
                        </label>
                        <input
                          value={this.state.fname.value}
                          className={this.state.fname.valid ? "form-control is-valid" : "form-control is-invalid"}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterNameEx"
                          placeholder="First name"
                          required
                        />
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterEmailEx2"
                          className="grey-text"
                        >
                          Last name
                        </label>
                        <input
                          value={this.state.lname.value}
                          className={this.state.lname.valid ? "form-control is-valid" : "form-control is-invalid"}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterEmailEx2"
                          placeholder="Last name"
                          required
                        />
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterConfirmEx3"
                          className="grey-text"
                        >
                          Email
                        </label>
                        <input
                          value={this.state.email.value}
                          className={this.state.email.valid ? "form-control is-valid" : "form-control is-invalid"}
                          onChange={this.changeHandler}
                          type="email"
                          id="defaultFormRegisterConfirmEx3"
                          name="email"
                          placeholder="Your Email address"
                        />
                        <small id="emailHelp" className="form-text text-muted">
                          We'll never share your email with anyone else.
                        </small>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          City
                        </label>
                        <input
                          value={this.state.city.value}
                          className={this.state.city.valid ? "form-control is-valid" : "form-control is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          name="city"
                          placeholder="City"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid city.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          State
                        </label>
                        <input
                          value={this.state.state.value}
                          className={this.state.state.valid ? "form-control is-valid" : "form-control is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          name="state"
                          placeholder="State"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid state.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          Zip
                        </label>
                        <input
                          value={this.state.zip.value}
                          className={this.state.zip.valid ? "form-control is-valid" : "form-control is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="zip"
                          placeholder="Zip"
                          required
                        />
                        <div className="invalid-feedback">
                          Please provide a valid zip.
                        </div>
                        <div className="valid-feedback">Looks good!</div>
                      </MDBCol>
                    </MDBRow>
                    <MDBCol md="4" className="mb-3">
                      <div className="custom-control custom-checkbox pl-3">
                        <input
                          className="custom-control-input"
                          type="checkbox"
                          value=""
                          id="invalidCheck"
                          required
                        />
                        <label className="custom-control-label" htmlFor="invalidCheck">
                          Agree to terms and conditions
                        </label>
                        <div className="invalid-feedback">
                          You must agree before submitting.
                        </div>
                      </div>
                    </MDBCol>
                    <MDBBtn color="primary" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Material styles MDB Pro component

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: {
                value: "Mark",
                valid: true
              },
              lname: {
                value: "Otto",
                valid: true
              },
              email: {
                value: "",
                valid: false
              },
              city: {
                value: "",
                valid: false
              },
              state: {
                value: "",
                valid: false
              },
              zip: {
                value: "",
                valid: false
              }
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: { value: event.target.value, valid: !!event.target.value } });
            };

            render() {
              return (
                <div>
                  <form>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.fname.value}
                          className={this.state.fname.valid ? "is-valid" : "is-invalid"}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterNameEx"
                          label="First name"
                          required
                        >
                          <div className="valid-feedback">Looks good!</div>
                          <div className="invalid-feedback">Provide a valid name!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.lname.value}
                          className={this.state.lname.valid ? "is-valid" : "is-invalid"}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterEmailEx2"
                          label="Last name"
                          required
                        >
                          <div className="valid-feedback">Looks good!</div>
                          <div className="invalid-feedback">Provide a valid last name!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.email.value}
                          className={this.state.email.valid ? "is-valid" : "is-invalid"}
                          onChange={this.changeHandler}
                          type="email"
                          id="materialFormRegisterConfirmEx3"
                          name="email"
                          label="Your Email address"
                        >
                          <small id="emailHelp" className="form-text text-muted">
                            We'll never share your email with anyone else.
                          </small>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.city.value}
                          className={this.state.city.valid ? "is-valid" : "is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="city"
                          label="City"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid city.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.state.value}
                          className={this.state.state.valid ? "is-valid" : "is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="state"
                          label="State"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid state.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.zip.value}
                          className={this.state.zip.valid ? "is-valid" : "is-invalid"}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="zip"
                          label="Zip"
                          required
                        >
                          <div className="invalid-feedback">
                            Please provide a valid zip.
                          </div>
                          <div className="valid-feedback">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBInput
                        type="checkbox"
                        value="conditions"
                        id="materialInvalidCheck"
                        required
                        label="Agree to terms and conditions"
                      >
                        <div className="invalid-feedback">
                          You must agree before submitting.
                        </div>
                      </MDBInput>
                    </MDBRow>
                    <MDBBtn color="success" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Supported elements

Default styles

Example invalid feedback text
More example invalid feedback text
Example invalid custom file feedback
        
            
            import React from "react";

            class FormsPage extends React.Component {
              render() {
                return (
                  <form className="was-validated" noValidate>
                    <div className="custom-control custom-checkbox mb-3">
                      <input
                        type="checkbox"
                        className="custom-control-input"
                        id="customControlValidation1"
                        required
                      />
                      <label
                        className="custom-control-label"
                        htmlFor="customControlValidation1"
                      >
                        Check this custom checkbox
                      </label>
                      <div className="invalid-feedback">
                        Example invalid feedback text
                      </div>
                    </div>

                    <div className="custom-control custom-radio">
                      <input
                        type="radio"
                        className="custom-control-input"
                        id="customControlValidation2"
                        name="radio-stacked"
                        required
                      />
                      <label
                        className="custom-control-label"
                        htmlFor="customControlValidation2"
                      >
                        Toggle this custom radio
                      </label>
                    </div>
                    <div className="custom-control custom-radio mb-3">
                      <input
                        type="radio"
                        className="custom-control-input"
                        id="customControlValidation3"
                        name="radio-stacked"
                        required
                      />
                      <label
                        className="custom-control-label"
                        htmlFor="customControlValidation3"
                      >
                        Or toggle this other custom radio
                      </label>
                      <div className="invalid-feedback">
                        More example invalid feedback text
                      </div>
                    </div>

                    <div className="custom-file">
                      <input
                        type="file"
                        className="custom-file-input"
                        id="validatedCustomFile"
                        required
                      />
                      <label
                        className="custom-file-label"
                        htmlFor="validatedCustomFile"
                      >
                        Choose file...
                      </label>
                      <div className="invalid-feedback">
                        Example invalid custom file feedback
                      </div>
                    </div>
                  </form>
                );
              }
            }

            export default FormsPage;

            
        
    

Material styles MDB Pro component

Example invalid feedback text
More example invalid feedback text
        
            
            import React from "react";
            import { MDBInput } from "mdbreact";

            class FormsPage extends React.Component {
              render() {
                return (
                  <form className="was-validated" noValidate>
                    <MDBInput
                      type="checkbox"
                      id="customControlValidation1"
                      label="Check this custom checkbox"
                      required
                    >
                      <div className="invalid-feedback">
                        Example invalid feedback text
                      </div>
                    </MDBInput>

                    <MDBInput
                      type="radio"
                      id="customControlValidation2"
                      name="radio-stacked"
                      required
                      label="Toggle this custom radio"
                    />

                    <MDBInput
                      type="radio"
                      id="customControlValidation3"
                      name="radio-stacked"
                      required
                      label="Or toggle this other custom radio"
                    >
                      <div className="invalid-feedback">
                        Example invalid feedback text
                      </div>
                    </MDBInput>
                  </form>
                );
              }
            }

            export default FormsPage;

            
        
    

Tooltips

If your form layout allows it, you can swap the .{valid|invalid}-feedback classes to .{valid|invalid}-tooltip classes to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative on it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Default styles

Looks good!
Looks good!
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += " was-validated";
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form
                    className="needs-validation"
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterNameEx"
                          className="grey-text"
                        >
                          First name
                        </label>
                        <input
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterNameEx"
                          className="form-control"
                          placeholder="First name"
                          required
                        />
                        <div className="valid-tooltip">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterEmailEx2"
                          className="grey-text"
                        >
                          Last name
                        </label>
                        <input
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterEmailEx2"
                          className="form-control"
                          placeholder="Last name"
                          required
                        />
                        <div className="valid-tooltip">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterConfirmEx3"
                          className="grey-text"
                        >
                          Email
                        </label>
                        <input
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="defaultFormRegisterConfirmEx3"
                          className="form-control"
                          name="email"
                          placeholder="Your Email address"
                        />
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          City
                        </label>
                        <input
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="city"
                          placeholder="City"
                          required
                        />
                        <div className="invalid-tooltip">
                          Please provide a valid city.
                        </div>
                        <div className="valid-tooltip">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          State
                        </label>
                        <input
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="state"
                          placeholder="State"
                          required
                        />
                        <div className="invalid-tooltip">
                          Please provide a valid state.
                        </div>
                        <div className="valid-tooltip">Looks good!</div>
                      </MDBCol>
                      <MDBCol md="4" className="mb-3">
                        <label
                          htmlFor="defaultFormRegisterPasswordEx4"
                          className="grey-text"
                        >
                          Zip
                        </label>
                        <input
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="defaultFormRegisterPasswordEx4"
                          className="form-control"
                          name="zip"
                          placeholder="Zip"
                          required
                        />
                        <div className="invalid-tooltip">
                          Please provide a valid zip.
                        </div>
                        <div className="valid-tooltip">Looks good!</div>
                      </MDBCol>
                    </MDBRow>
                    <MDBBtn color="primary" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Material styles MDB Pro component

Looks good!
Looks good!
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += " was-validated";
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form
                    className="needs-validation"
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.fname}
                          name="fname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterNameEx"
                          label="First name"
                          required
                        >
                          <div className="valid-tooltip">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.lname}
                          name="lname"
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterEmailEx2"
                          label="Last name"
                          required
                        >
                          <div className="valid-tooltip">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type="email"
                          id="materialFormRegisterConfirmEx3"
                          name="email"
                          label="Your Email address"
                        >
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="city"
                          label="City"
                          required
                        >
                          <div className="invalid-tooltip">
                            Please provide a valid city.
                          </div>
                          <div className="valid-tooltip">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="state"
                          label="State"
                          required
                        >
                          <div className="invalid-tooltip">
                            Please provide a valid state.
                          </div>
                          <div className="valid-tooltip">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md="4">
                        <MDBInput
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type="text"
                          id="materialFormRegisterPasswordEx4"
                          name="zip"
                          label="Zip"
                          required
                        >
                          <div className="invalid-tooltip">
                            Please provide a valid zip.
                          </div>
                          <div className="valid-tooltip">Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBBtn color="success" type="submit">
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

Inputs with icons

In input with icon, validation feedback appear for default at the beginning of the line under icon. If you want to display validation exactly under input, you must add additional classes after valid-feedback class in your validation feedback container.

In outline styles : ml-3 pl-3, for example: <div class="valid-feedback ml-3 pl-3"> Valid feedback. <div>

In material styles : ml-4 pl-3, for example: <div class="invalid-feedback ml-4 pl-3"> Invalid feedback. <div>

Outline styles

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from 'react';
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from 'mdbreact';

          class FormsPage extends React.Component {
            state = {
              fname: 'Mark',
              lname: 'Otto',
              email: '',
              city: '',
              state: '',
              zip: ''
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += ' was-validated';
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                  <form
                    className='needs-validation'
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='user'
                          value={this.state.fname}
                          name='fname'
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterNameEx'
                          label='First name'
                          outline
                          required
                        >
                          <div className='valid-feedback ml-3 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='address-card'
                          value={this.state.lname}
                          name='lname'
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterEmailEx2'
                          label='Last name'
                          outline
                          required
                        >
                          <div className='valid-feedback ml-3 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='envelope-open'
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type='email'
                          id='materialFormRegisterConfirmEx3'
                          name='email'
                          label='Your Email address'
                          outline
                        >
                          <small id='emailHelp' className='form-text text-muted'>
                            We'll never share your email with anyone else.
                          </small>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='city'
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='city'
                          label='City'
                          outline
                          required
                        >
                          <div className='invalid-feedback ml-3 pl-3'>
                            Please provide a valid city.
                          </div>
                          <div className='valid-feedback ml-3 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='map-marked-alt'
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='state'
                          label='State'
                          outline
                          required
                        >
                          <div className='invalid-feedback ml-3 pl-3'>
                            Please provide a valid state.
                          </div>
                          <div className='valid-feedback ml-3 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='location-arrow'
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='zip'
                          label='Zip'
                          outline
                          required
                        >
                          <div className='invalid-feedback ml-3 pl-3'>
                            Please provide a valid zip.
                          </div>
                          <div className='valid-feedback ml-3 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBCol md='4' className='mb-3'>
                      <div className='custom-control custom-checkbox pl-3'>
                        <input
                          className='custom-control-input'
                          type='checkbox'
                          value=''
                          id='invalidCheck'
                          required
                        />
                        <label className='custom-control-label' htmlFor='invalidCheck'>
                          Agree to terms and conditions
                        </label>
                        <div className='invalid-feedback'>
                          You must agree before submitting.
                        </div>
                      </div>
                    </MDBCol>
                    <MDBBtn color='primary' type='submit'>
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;

       
        
    

Material styles MDB Pro component

Looks good!
Looks good!
We'll never share your email with anyone else.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          import React from "react";
          import { MDBRow, MDBCol, MDBInput, MDBBtn } from "mdbreact";

          class FormsPage extends React.Component {
            state = {
              fname: "Mark",
              lname: "Otto",
              email: "",
              city: "",
              state: "",
              zip: ""
            };

            submitHandler = event => {
              event.preventDefault();
              event.target.className += " was-validated";
            };

            changeHandler = event => {
              this.setState({ [event.target.name]: event.target.value });
            };

            render() {
              return (
                <div>
                    <form
                    className='needs-validation'
                    onSubmit={this.submitHandler}
                    noValidate
                  >
                    <MDBRow>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='user'
                          value={this.state.fname}
                          name='fname'
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterNameEx'
                          label='First name'
                          required
                        >
                          <div className='valid-feedback ml-4 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='address-card'
                          value={this.state.lname}
                          name='lname'
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterEmailEx2'
                          label='Last name'
                          required
                        >
                          <div className='valid-feedback ml-4 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='envelope-open'
                          value={this.state.email}
                          onChange={this.changeHandler}
                          type='email'
                          id='materialFormRegisterConfirmEx3'
                          name='email'
                          label='Your Email address'
                        >
                          <small id='emailHelp' className='form-text text-muted'>
                            We'll never share your email with anyone else.
                          </small>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='city'
                          value={this.state.city}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='city'
                          label='City'
                          required
                        >
                          <div className='invalid-feedback ml-4 pl-3'>
                            Please provide a valid city.
                          </div>
                          <div className='valid-feedback ml-4 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='map-marked-alt'
                          value={this.state.state}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='state'
                          label='State'
                          required
                        >
                          <div className='invalid-feedback ml-4 pl-3'>
                            Please provide a valid state.
                          </div>
                          <div className='valid-feedback ml-4 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                      <MDBCol md='4'>
                        <MDBInput
                          icon='location-arrow'
                          value={this.state.zip}
                          onChange={this.changeHandler}
                          type='text'
                          id='materialFormRegisterPasswordEx4'
                          name='zip'
                          label='Zip'
                          required
                        >
                          <div className='invalid-feedback ml-4 pl-3'>
                            Please provide a valid zip.
                          </div>
                          <div className='valid-feedback ml-4 pl-3'>Looks good!</div>
                        </MDBInput>
                      </MDBCol>
                    </MDBRow>
                    <MDBRow>
                      <MDBInput
                        type='checkbox'
                        value='conditions'
                        id='materialInvalidCheck'
                        required
                        label='Agree to terms and conditions'
                      >
                        <div className='invalid-feedback'>
                          You must agree before submitting.
                        </div>
                      </MDBInput>
                    </MDBRow>
                    <MDBBtn color='primary' type='submit'>
                      Submit Form
                    </MDBBtn>
                  </form>
                </div>
              );
            }
          }

          export default FormsPage;
       
        
    

React Validation - API

In this section you will find advanced information about the React Validation component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

In order to use Validation component make sure you have imported proper module first.

        
            
          import React from 'react';
          import { MDBInput } from 'mdbreact';
        
        
    

Usage

Here’s how form validation works with Bootstrap:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <input>, <select>, and <textarea> elements.
  • Bootstrap scopes the :invalid and :valid styles to parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid on page load. This way, you may choose when to activate them (typically after form submission is attempted).
  • To reset the appearance of the form (for instance, in the case of dynamic form submissions using AJAX), remove the .was-validated class from the <form> again after submission.
  • As a fallback, .is-invalid and .is-valid classes may be used instead of the pseudo-classes for server side validation. They do not require a .was-validated parent class.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles.
  • You may provide custom validity messages with just passing the elements with classes .valid-feedback and .invalid-feedback as children of the MDBInput component.
        
            
       import React from "react";
       import { MDBInput } from "mdbreact";
       
       class FormExample extends React.Component {
         state = {
           fname: "Mark"
         };
       
         submitHandler = event => {
           event.preventDefault();
           event.target.className += " was-validated";
         };
       
         changeHandler = event => {
           this.setState({ [event.target.name]: event.target.value });
         };
       
         render() {
           return (
             <form
               className="needs-validation"
               onSubmit={this.submitHandler}
               noValidate
             >
               <MDBInput
                 value={this.state.fname}
                 name="fname"
                 onChange={this.changeHandler}
                 type="text"
                 id="materialFormRegisterNameEx"
                 label="First name"
                 required
               >
                 <div className="valid-feedback">Looks good!</div>
                 <div className="invalid-feedback">Try better next time!</div>
               </MDBInput>
             </form>
           );
         }
       }

       export default FormExample;
       
        
    

API Reference: Properties

The table below shows the configuration options of the MDBInput component.

Name Type Default Description Example
checked Boolean false Pre-selects checkbox/radio button when the page loads. <MDBInput checked />
className String Adds custom class to Input component <MDBInput className="myClass" />
containerClass String Adds custom class to wrapping div <MDBInput containerClass="wrapper" />
disabled Boolean false Disables input component <MDBInput disabled />
error String Sets the error message for the labels data-error attribute <MDBInput error="Whoops!" />
filled Boolean false Add filled-in style to checkbox/radio button <MDBInput type="checkbox" filled />
gap Boolean false Creates gap inside checkbox/radio button <MDBInput type="checkbox" gap />
group Boolean false Add .form-group class to the wrapping div <MDBInput group />
hint String Sets the placeholder for the Input <MDBInput hint="Placeholder" />
icon String Adds font-awesome icon <MDBInput icon="caret-right" />
iconBrand Boolean false Use this property to set brand icon (fab) <MDBInput icon="twitter" iconBrand />
iconClassName String Adds custom classes to icon element <MDBInput icon="envelope" iconClassName="customClass" />
iconLight Boolean false Use this property to set light icon (fal) <MDBInput icon="twitter" iconLight />
iconRegular Boolean false Use this property to set regular icon (far) <MDBInput icon="twitter" iconRegular />
iconSize String Sets icon size <MDBInput icon="pencil-alt" size="5x" />
id String Required! Set the id of the input element <MDBInput id="myId" />
inputRef Function Allows to attach React Ref to the input component; accepts only Callback Ref <MDBInput inputRef={ref => this.myRef = ref } />
label String Add label to the component; you can attach jsx elements (f.e. links) <MDBInput label="My custom input" />
labelClass String Adds custom class to the label <MDBInput labelClass="labelCustomClass" />
size String Changes size of the component; available lg and sm <MDBInput size="sm" />
success String Sets the success message for the labels data-success attribute <MDBInput success="Yeah!" />
tag String input Changes default input tag <MDBInput tag="div" />
type String text The type of the input element <MDBInput type="checkbox" />
validate Boolean false Adds .validate class to the Input component <MDBInput validate />
value String The value of the input element (use with the controlled input) <MDBInput value="I am controlled" onChange={this.handleChange} />
valueDefault String The default value of the input (use with the uncontrolled input) <MDBInput valueDefault="I am uncontrolled" />

API Reference: Methods

The table below shows the methods which you can use with MDBInput component.

Name Parameters Description Example
getValue Method called on input change event; returns input value <MDBInput getValue={this.getValue} />
onBlur Method called on blur event, the blur event is raised when an element loses focus; returns event object <MDBInput onBlur={this.handleBlur} />
onChange Method called on change event; returns event object <MDBInput onChange={this.handleChange} />
onFocus Method called on focus event, the focus event is raised when the user sets focus on en element; returns event object <MDBInput onFocus={this.handleFocus} />
onInput Method called on input event; returns event object <MDBInput onInput={this.handleInput} />

Vue Bootstrap Validation

Vue Validation - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Provide valuable, actionable feedback to your users with HTML5 form validation – available in all our supported browsers. Choose from the browser default validation feedback, or implement custom messages with our built-in classes and starter JavaScript.

Warning

We currently recommend using custom validation styles, as native browser default validation messages are not consistently exposed to assistive technologies in all browsers (most notably, Chrome on desktop and mobile).


How it works

Here’s how form validation works with Bootstrap:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <input>, <select>, and <textarea> elements.
  • Bootstrap scopes the :invalid and :valid styles to parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid on page load. This way, you may choose when to activate them (typically after form submission is attempted).
  • To reset the appearance of the form (for instance, in the case of dynamic form submissions using AJAX), remove the .was-validated class from the <form> again after submission.
  • As a fallback, .is-invalid and .is-valid classes may be used instead of the pseudo-classes for server side validation. They do not require a .was-validated parent class.
  • Due to constraints in how CSS works, we cannot (at present) apply styles to a <label> that comes before a form control in the DOM without the help of custom JavaScript.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles with additional HTML and CSS.
  • You may provide custom validity messages with setCustomValidity in JavaScript.

With that in mind, consider the following demos for our custom form validation styles, optional server side classes, and browser defaults.


Custom styles

For custom Bootstrap form validation messages, you’ll need to add the novalidate boolean attribute to your <form>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript. Try to submit the form below; our JavaScript will intercept the submit button and relay feedback to you.

When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Default styles

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          <template>
            <mdb-container class="mt-5">
              <h1 class="my-5">Form Validation</h1>
              <!-- Custom styles -->
              <h2 class="my-5">Custom styles</h2>
              <form class="needs-validation" novalidate @submit="checkForm">
                <div class="form-row">
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom01">First name</label>
                    <input type="text" class="form-control" id="validationCustom01" placeholder="First name"
                      value="Mark" required>
                    <div class="valid-feedback">
                      Looks good!
                    </div>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom02">Last name</label>
                    <input type="text" class="form-control" id="validationCustom02" placeholder="Last name" value="Otto"
                      required>
                    <div class="valid-feedback">
                      Looks good!
                    </div>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustomUsername">Username</label>
                    <div class="input-group">
                      <div class="input-group-prepend">
                        <span class="input-group-text" id="inputGroupPrepend">@</span>
                      </div>
                      <input type="text" class="form-control" id="validationCustomUsername" placeholder="Username"
                        aria-describedby="inputGroupPrepend" required>
                      <div class="invalid-feedback">
                        Please choose a username.
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-row">
                  <div class="col-md-6 mb-3">
                    <label for="validationCustom03">City</label>
                    <input type="text" class="form-control" id="validationCustom03" placeholder="City" required>
                    <div class="invalid-feedback">
                      Please provide a valid city.
                    </div>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom04">State</label>
                    <input type="text" class="form-control" id="validationCustom04" placeholder="State" required>
                    <div class="invalid-feedback">
                      Please provide a valid state.
                    </div>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom05">Zip</label>
                    <input type="text" class="form-control" id="validationCustom05" placeholder="Zip" required>
                    <div class="invalid-feedback">
                      Please provide a valid zip.
                    </div>
                  </div>
                </div>
                <div class="form-group">
                  <div class="form-check pl-0">
                    <input class="form-check-input" type="checkbox" value="" id="invalidCheck" required>
                    <label class="form-check-label" for="invalidCheck">
                      Agree to terms and conditions
                    </label>
                    <div class="invalid-feedback">
                      You must agree before submitting.
                    </div>
                  </div>
                </div>
                <mdb-btn type="submit">Submit form</mdb-btn>
              </form>
            </mdb-container>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbContainer,
              mdbBtn
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbContainer,
                mdbBtn
              },
              methods: {
                checkForm(event) {
                  event.preventDefault();
                  event.target.classList.add('was-validated');
                }
              }
            }
          </script>
          
        
    

Material styles MDB Pro component

Looks good!
Looks good!
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
            <template>
              <form novalidate @submit.prevent="checkForm">
                <div class="form-row">
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom10" placeholder="First name" label="First name"
                      value="Mark" required validFeedback="Look's good." />
                  </div>
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom11" placeholder="Last name" label="Last name"
                      value="Otto" required validFeedback="Look's good." />
                  </div>
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom12" placeholder="Username" label="Username" required
                      invalidFeedback="Please choose a username." />
                  </div>
                </div>
                <div class="form-row">
                  <div class="col-md-6">
                    <mdb-input type="text" id="validationCustom13" placeholder="City" label="City" required
                      invalidFeedback="Please provide a valid city." />
                  </div>
                  <div class="col-md-3">
                    <mdb-input type="text" id="validationCustom14" placeholder="State" label="State" required
                      invalidFeedback="Please provide a valid state." />
                  </div>
                  <div class="col-md-3">
                    <mdb-input type="text" id="validationCustom15" placeholder="Zip" label="Zip" required
                      invalidFeedback="Please provide a valid zip." />
                  </div>
                </div>
                <div class="form-group">
                  <mdb-input type="checkbox" class="pl-0" id="invalidCheck" label="Agree to terms and conditions"
                    required invalidFeedback="You must agree before submitting." />
                </div>
                <mdb-btn type="submit">Submit form</mdb-btn>
              </form>
            </template>
            
        
    
        
            
            <script>
              import {
                mdbContainer,
                mdbBtn,
                mdbIcon,
                mdbRow,
                mdbCol,
                mdbInput
              } from "mdbvue";
              export default {
                name: "ValidationPagePro",
                components: {
                  mdbContainer,
                  mdbBtn,
                  mdbIcon,
                  mdbRow,
                  mdbCol,
                  mdbInput
                },
                methods: {
                  checkForm(event) {
                    event.target.classList.add('was-validated');
                  }
                }
              };
            </script>
            
        
    

Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? All good, you can use the browser defaults. Try submitting the form below. Depending on your browser and OS, you’ll see a slightly different style of feedback.

While these feedback styles cannot be styled with CSS, you can still customize the feedback text through JavaScript.

Default styles

@
        
            
          <template>
            <mdb-container class="mt-5">
              <form>
                <div class="form-row">
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom01">First name</label>
                    <input type="text" class="form-control" id="validationCustom01" placeholder="First name"
                      value="Mark" required>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom02">Last name</label>
                    <input type="text" class="form-control" id="validationCustom02" placeholder="Last name" value="Otto"
                      required>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustomUsername">Username</label>
                    <div class="input-group">
                      <div class="input-group-prepend">
                        <span class="input-group-text" id="inputGroupPrepend">@</span>
                      </div>
                      <input type="text" class="form-control" id="validationCustomUsername" placeholder="Username"
                        aria-describedby="inputGroupPrepend" required>
                    </div>
                  </div>
                </div>
                <div class="form-row">
                  <div class="col-md-6 mb-3">
                    <label for="validationCustom03">City</label>
                    <input type="text" class="form-control" id="validationCustom03" placeholder="City" required>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom04">State</label>
                    <input type="text" class="form-control" id="validationCustom04" placeholder="State" required>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom05">Zip</label>
                    <input type="text" class="form-control" id="validationCustom05" placeholder="Zip" required>
                  </div>
                </div>
                <div class="form-group">
                  <div class="form-check pl-0">
                    <input class="form-check-input" type="checkbox" value="" id="invalidCheck" required>
                    <label class="form-check-label" for="invalidCheck">
                      Agree to terms and conditions
                    </label>
                  </div>
                </div>
                <mdb-btn type="submit">Submit form</mdb-btn>
              </form>
            </mdb-container>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbContainer,
              mdbBtn
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbContainer,
                mdbBtn
              }
            }
          </script>
          
        
    

Material stylesMDB Pro component

        
            
            <template>
              <form>
                <div class="form-row">
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom1" placeholder="First name" label="First name"
                      value="Mark" required validFeedback="Look's good." />
                  </div>
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom2" placeholder="Last name" label="Last name" value="Otto"
                      required validFeedback="Look's good." />
                  </div>
                  <div class="col-md-4">
                    <mdb-input type="text" id="validationCustom3" placeholder="Username" label="Username" required
                      invalidFeedback="Please choose a username." />
                  </div>
                </div>
                <div class="form-row">
                  <div class="col-md-6">
                    <mdb-input type="text" id="validationCustom4" placeholder="City" label="City" required
                      invalidFeedback="Please provide a valid city." />
                  </div>
                  <div class="col-md-3">
                    <mdb-input type="text" id="validationCustom5" placeholder="State" label="State" required
                      invalidFeedback="Please provide a valid state." />
                  </div>
                  <div class="col-md-3">
                    <mdb-input type="text" id="validationCustom6" placeholder="Zip" label="Zip" required
                      invalidFeedback="Please provide a valid zip." />
                  </div>
                </div>
                <div class="form-group">
                  <mdb-input type="checkbox" class="pl-0" id="invalidCheck2" label="Agree to terms and conditions"
                    required invalidFeedback="You must agree before submitting." />
                </div>
                <mdb-btn type="submit">Submit form</mdb-btn>
              </form>
            </template>
            
        
    
        
            
            <script>
              import {
                mdbContainer,
                mdbBtn,
                mdbIcon,
                mdbRow,
                mdbCol,
                mdbInput
              } from "mdbvue";
              export default {
                name: "ValidationPagePro",
                components: {
                  mdbContainer,
                  mdbBtn,
                  mdbIcon,
                  mdbRow,
                  mdbCol,
                  mdbInput
                }
              };
            </script>
            
        
    

Server side

We recommend using client side validation, but in case you require server side, you can indicate invalid and valid form fields with .is-invalid and .is-valid. Note that .invalid-feedback is also supported with these classes.

Default styles

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
You must agree before submitting.
        
            
          <template>
            <mdb-container class="mt-5">
              <form class="needs-validation" novalidate @submit="checkForm">
                <div class="form-row">
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom01">First name</label>
                    <input type="text" class="form-control is-valid" id="validationCustom01" placeholder="First name"
                      value="Mark" required>
                    <div class="valid-feedback">
                      Looks good!
                    </div>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustom02">Last name</label>
                    <input type="text" class="form-control is-valid" id="validationCustom02" placeholder="Last name"
                      value="Otto" required>
                    <div class="valid-feedback">
                      Looks good!
                    </div>
                  </div>
                  <div class="col-md-4 mb-3">
                    <label for="validationCustomUsername">Username</label>
                    <div class="input-group">
                      <div class="input-group-prepend">
                        <span class="input-group-text" id="inputGroupPrepend">@</span>
                      </div>
                      <input type="text" class="form-control is-invalid" id="validationCustomUsername"
                        placeholder="Username" aria-describedby="inputGroupPrepend" required>
                      <div class="invalid-feedback">
                        Please choose a username.
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-row">
                  <div class="col-md-6 mb-3">
                    <label for="validationCustom03">City</label>
                    <input type="text" class="form-control is-invalid" id="validationCustom03" placeholder="City"
                      required>
                    <div class="invalid-feedback">
                      Please provide a valid city.
                    </div>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom04">State</label>
                    <input type="text" class="form-control is-invalid" id="validationCustom04" placeholder="State"
                      required>
                    <div class="invalid-feedback">
                      Please provide a valid state.
                    </div>
                  </div>
                  <div class="col-md-3 mb-3">
                    <label for="validationCustom05">Zip</label>
                    <input type="text" class="form-control is-invalid" id="validationCustom05" placeholder="Zip"
                      required>
                    <div class="invalid-feedback">
                      Please provide a valid zip.
                    </div>
                  </div>
                </div>
                <div class="form-group">
                  <div class="form-check pl-0">
                    <input class="form-check-input is-invalid" type="checkbox" value="" id="invalidCheck" required>
                    <label class="form-check-label" for="invalidCheck">
                      Agree to terms and conditions
                    </label>
                    <div class="invalid-feedback">
                      You must agree before submitting.
                    </div>
                  </div>
                </div>
                <mdb-btn type="submit">Submit form</mdb-btn>
              </form>
            </mdb-container>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbContainer,
              mdbBtn
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbContainer,
                mdbBtn
              },
              methods: {
                checkForm(event) {
                  event.preventDefault();
                  event.target.classList.add('was-validated');
                }
              }
            }
          </script>
          
        
    

Material styles

Looks good!
Looks good!
Please choose a username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
You must agree before submitting.
        
            
          <template>
            <form class="was-validated" novalidate>
              <div class="form-row">
                <div class="col-md-4">
                  <mdb-input type="text" id="validationCustom21" placeholder="First name" label="First name"
                    value="Mark" required validFeedback="Look's good." />
                </div>
                <div class="col-md-4">
                  <mdb-input type="text" id="validationCustom22" placeholder="Last name" label="Last name" value="Otto"
                    required validFeedback="Look's good." />
                </div>
                <div class="col-md-4">
                  <mdb-input type="text" id="validationCustom23" placeholder="Username" label="Username" required
                    invalidFeedback="Please choose a username." />
                </div>
              </div>
              <div class="form-row">
                <div class="col-md-6">
                  <mdb-input type="text" id="validationCustom24" placeholder="City" label="City" required
                    invalidFeedback="Please provide a valid city." />
                </div>
                <div class="col-md-3">
                  <mdb-input type="text" id="validationCustom25" placeholder="State" label="State" required
                    invalidFeedback="Please provide a valid state." />
                </div>
                <div class="col-md-3">
                  <mdb-input type="text" id="validationCustom26" placeholder="Zip" label="Zip" required
                    invalidFeedback="Please provide a valid zip." />
                </div>
              </div>
              <div class="form-group">
                <mdb-input type="checkbox" class="pl-0" id="invalidCheck22" label="Agree to terms and conditions"
                  required invalidFeedback="You must agree before submitting." />
              </div>
              <mdb-btn type="submit">Submit form</mdb-btn>
            </form>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbContainer,
              mdbBtn,
              mdbIcon,
              mdbRow,
              mdbCol,
              mdbInput
            } from "mdbvue";
            export default {
              name: "ValidationPagePro",
              components: {
                mdbContainer,
                mdbBtn,
                mdbIcon,
                mdbRow,
                mdbCol,
                mdbInput
              }
            };
          </script>
          
        
    

Supported elements

Our example forms show native textual <input>s above, but form validation styles are available for our custom form controls, too.

Default styles

Example invalid feedback text
More example invalid feedback text
Example invalid custom select feedback
Example invalid custom file feedback
        
            
          <template>
            <mdb-container class="mt-5">
              <!-- Supported elements -->
              <hr class="my-5">
              <h2 class="my-5">Supported elements</h2>
              <form class="was-validated">
                <div class="custom-control custom-checkbox mb-3">
                  <input type="checkbox" class="custom-control-input" id="customControlValidation1" required>
                  <label class="custom-control-label" for="customControlValidation1">Check this custom checkbox</label>
                  <div class="invalid-feedback">Example invalid feedback text</div>
                </div>
                <div class="custom-control custom-radio">
                  <input type="radio" class="custom-control-input" id="customControlValidation2" name="radio-stacked"
                    required>
                  <label class="custom-control-label" for="customControlValidation2">Toggle this custom radio</label>
                </div>
                <div class="custom-control custom-radio mb-3">
                  <input type="radio" class="custom-control-input" id="customControlValidation3" name="radio-stacked"
                    required>
                  <label class="custom-control-label" for="customControlValidation3">Or toggle this other custom
                    radio</label>
                  <div class="invalid-feedback">More example invalid feedback text</div>
                </div>
                <div class="form-group">
                  <select class="custom-select browser-default" required>
                    <option value="">Open this select menu</option>
                    <option value="1">One</option>
                    <option value="2">Two</option>
                    <option value="3">Three</option>
                  </select>
                  <div class="invalid-feedback">Example invalid custom select feedback</div>
                </div>
                <div class="custom-file">
                  <input type="file" class="custom-file-input" id="validatedCustomFile" required>
                  <label class="custom-file-label" for="validatedCustomFile">Choose file...</label>
                  <div class="invalid-feedback">Example invalid custom file feedback</div>
                </div>
              </form>
            </mdb-container>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbContainer
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbContainer
              },
              methods: {
                checkForm(event) {
                  event.preventDefault();
                  event.target.classList.add('was-validated');
                }
              }
            }
          </script>
          
        
    

Material styles MDB Pro component

Example invalid feedback text
More example invalid feedback text
Choose file
Example invalid custom file feedback
        
            
            <template>
              <form class="was-validated">
                <mdb-input type="checkbox" id="customControlValidation31" required label="Check this custom checkbox"
                  invalidFeedback="Example invalid feedback text" />
                <mdb-input type="radio" class="mt-3" id="option1-1" name="option1" label="Toggle this material radio"
                  required />
                <mdb-input type="radio" id="option1-2" name="option1" label="Or toggle this other material radio"
                  required invalidFeedback="Example invalid feedback text" />
                <mdb-file-input btnColor="primary" />
              </form>
            </template>
            
        
    
        
            
            <script>
              import {
                mdbInput,
                mdbFileInput
              } from "mdbvue";
              export default {
                name: "ValidationPagePro",
                components: {
                  mdbInput,
                  mdbFileInput
                }
              };
            </script>
            
        
    

Tooltips

If your form layout allows it, you can swap the .{valid|invalid}-feedback classes for .{valid|invalid}-tooltip classes to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative on it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Looks good!
Looks good!
@
Please choose a unique and valid username.
Please provide a valid city.
Please provide a valid state.
Please provide a valid zip.
        
            
      <template>
        <mdb-container class="mt-5">
          <!-- Tooltips -->
          <hr class="my-5">
          <h2 class="my-5">Tooltips</h2>
          <form class="needs-validation" novalidate @submit="checkForm">
            <div class="form-row">
              <div class="col-md-4 mb-3">
                <label for="validationTooltip01">First name</label>
                <input type="text" class="form-control" id="validationTooltip01" placeholder="First name" value="Mark"
                  required>
                <div class="valid-tooltip">
                  Looks good!
                </div>
              </div>
              <div class="col-md-4 mb-3">
                <label for="validationTooltip02">Last name</label>
                <input type="text" class="form-control" id="validationTooltip02" placeholder="Last name" value="Otto"
                  required>
                <div class="valid-tooltip">
                  Looks good!
                </div>
              </div>
              <div class="col-md-4 mb-3">
                <label for="validationTooltipUsername">Username</label>
                <div class="input-group">
                  <div class="input-group-prepend">
                    <span class="input-group-text" id="validationTooltipUsernamePrepend">@</span>
                  </div>
                  <input type="text" class="form-control" id="validationTooltipUsername" placeholder="Username"
                    aria-describedby="validationTooltipUsernamePrepend" required>
                  <div class="invalid-tooltip">
                    Please choose a unique and valid username.
                  </div>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="col-md-6 mb-3">
                <label for="validationTooltip03">City</label>
                <input type="text" class="form-control" id="validationTooltip03" placeholder="City" required>
                <div class="invalid-tooltip">
                  Please provide a valid city.
                </div>
              </div>
              <div class="col-md-3 mb-3">
                <label for="validationTooltip04">State</label>
                <input type="text" class="form-control" id="validationTooltip04" placeholder="State" required>
                <div class="invalid-tooltip">
                  Please provide a valid state.
                </div>
              </div>
              <div class="col-md-3 mb-3">
                <label for="validationTooltip05">Zip</label>
                <input type="text" class="form-control" id="validationTooltip05" placeholder="Zip" required>
                <div class="invalid-tooltip">
                  Please provide a valid zip.
                </div>
              </div>
            </div>
            <mdb-btn type="submit">Submit form</mdb-btn>
          </form>
        </mdb-container>
      </template>
      
        
    
        
            
      <script>
        import {
          mdbContainer,
          mdbBtn
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbContainer,
            mdbBtn
          },
          methods: {
            checkForm(event) {
              event.preventDefault();
              event.target.classList.add('was-validated');
            }
          }
        }
      </script>
      
        
    

Material Select Validation MDB Pro component"

Please select a country.
You shall not pass!
        
            
        <template>
          <mdb-row>
            <mdb-col sm="6">
              <mdb-select v-model="validateOptions" validation ref="validationSelect" resetBtn label="validate" />
              <mdb-btn size="sm" color="primary" @click.native="$refs.validationSelect.validate()">Validate</mdb-btn>
            </mdb-col>
          </mdb-row>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbBtn,
            mdbRow,
            mdbCol,
            mdbSelect
          } from "mdbvue";
          export default {
            name: "ValidationPagePro",
            components: {
              mdbBtn,
              mdbRow,
              mdbCol,
              mdbSelect
            },
            data() {
              return {
                validateOptions: [{
                    text: 'Option nr 1',
                    value: 'Option 1'
                  },
                  {
                    text: 'Option nr 2',
                    value: 'Option 2'
                  },
                  {
                    text: 'Option nr 3',
                    value: 'Option 3'
                  },
                  {
                    text: 'Option nr 4',
                    value: 'Option 4'
                  },
                  {
                    text: 'Option nr 5',
                    value: 'Option 5'
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Custom validation MDB Pro component

Here's an example code of custom validation. It could be helpful if You want to apply multiple conditions to Your form inputs.

        
            
        <template>
          <form @submit.prevent="validateForm" novalidate>
            <mdb-input type="text" id="customInput1" label="First name" v-model="customValues.name"
              :customValidation="validation.name.validated" :isValid="validation.name.valid" @change="validate('name')"
              required validFeedback="Look's good." invalidFeedback="Please correct." />
            <mdb-input type="text" id="customInput2" label="Last name" v-model="customValues.lastname"
              :customValidation="validation.lastname.validated" :isValid="validation.lastname.valid"
              @change="validate('lastname')" required validFeedback="Look's good." invalidFeedback="Please correct." />
            <mdb-input type="text" id="customInput3" label="Country" v-model="customValues.country"
              :customValidation="validation.country.validated" :isValid="validation.country.valid"
              @change="validate('country')" required validFeedback="Look's good."
              invalidFeedback="Country should be one of those: USA, France, Poland" />
            <mdb-row>
              <mdb-col>
                <mdb-select v-model="city" validation @change="validate('city')" ref="select"
                  validFeedback="Look's good." invalidFeedback="Please choose Your city." label="City"
                  placeholder="Choose your city" />
              </mdb-col>
            </mdb-row>
            <mdb-input type="password" id="customInput4" label="Password" v-model="customValues.password"
              :customValidation="validation.password.validated" :isValid="validation.password.valid"
              @change="validate('password')" required validFeedback="Look's good."
              :invalidFeedback="validation.password.invalidFeedback" />
            <mdb-input class="pl-0 mb-3" type="checkbox" id="customInput5" v-model="customValues.checkbox"
              :customValidation="validation.checkbox.validated" :isValid="validation.checkbox.valid"
              @change="validate('checkbox')" required label="Check this custom checkbox" validFeedback="Correct"
              invalidFeedback="Please check me" />
            <mdb-btn type="Submit" size="sm" color="danger">Submit</mdb-btn>
          </form>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbBtn,
            mdbRow,
            mdbCol,
            mdbInput,
            mdbSelect
          } from "mdbvue";
          export default {
            name: "ValidationPagePro",
            components: {
              mdbBtn,
              mdbRow,
              mdbCol,
              mdbInput,
              mdbSelect
            },
            data() {
              return {
                customValues: {
                  name: "Matt",
                  lastname: "Doe",
                  country: "",
                  city: "",
                  password: "",
                  checkbox: false,
                  datepicker: ""
                },
                validation: {
                  name: {
                    valid: false,
                    validated: false
                  },
                  lastname: {
                    valid: false,
                    validated: false
                  },
                  country: {
                    valid: false,
                    validated: false
                  },
                  city: {
                    valid: false,
                    validated: false
                  },
                  password: {
                    valid: false,
                    validated: false,
                    invalidFeedback: ''
                  },
                  checkbox: {
                    valid: false,
                    validated: false
                  }
                }
              };
            },
            computed: {
              city() {
                if (this.customValues.country === 'USA') {
                  return [{
                      text: 'Boston',
                      value: 'boston'
                    },
                    {
                      text: 'Chicago',
                      value: 'chicago'
                    },
                    {
                      text: 'New York',
                      value: 'newYork'
                    }
                  ];
                } else if (this.customValues.country === 'France') {
                  return [{
                      text: 'Paris',
                      value: 'paris'
                    },
                    {
                      text: 'Nantes',
                      value: 'nantes'
                    },
                    {
                      text: 'Lyon',
                      value: 'lyon'
                    }
                  ];
                } else if (this.customValues.country === 'Poland') {
                  return [{
                      text: 'Warszawa',
                      value: 'warszawa'
                    },
                    {
                      text: 'Kraków',
                      value: 'krakow'
                    },
                    {
                      text: 'Gdańsk',
                      value: 'gdansk'
                    },
                  ];
                }
                return [];
              }
            },
            methods: {
              validateForm() {
                Object.keys(this.customValues).forEach(key => {
                  this.validate(key);
                });
              },
              validate(key, value) {
                if (key === "name" || key === "lastname" || key === "checkbox") {
                  if (this.customValues[key]) {
                    this.validation[key].valid = true;
                  } else {
                    this.validation[key].valid = false;
                  }
                  this.validation[key].validated = true;
                }
                if (key === "country") {
                  if (["USA", "France", "Poland"].includes(this.customValues[key])) {
                    this.validation[key].valid = true;
                  } else {
                    this.validation[key].valid = false;
                  }
                  this.validation[key].validated = true;
                }
                if (key === "password") {
                  // check length
                  if (this.customValues[key].length > 5) {
                    // check uppercase
                    for (let character of this.customValues[key].split("")) {
                      if (character === character.toUpperCase()) {
                        this.validation[key].valid = true;
                        break;
                      }
                      this.validation[key].valid = false;
                      this.validation[key].invalidFeedback =
                        "Password should contain at least one uppercase character.";
                    }
                  } else {
                    this.validation[key].valid = false;
                    this.validation[key].invalidFeedback =
                      "Password too short. Type at least 6 letters.";
                  }
                  this.validation[key].validated = true;
                }
                if (key === "city") {
                  this.$refs.select.validate();
                }
                if (key === "arrival") {
                  if (value) {
                    this.validation[key].valid = true;
                  } else {
                    this.validation[key].valid = false;
                  }
                  this.validation[key].validated = true;
                }
              },
            }
          };
        </script>

Angular Bootstrap Validation

Angular Validation - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Angular Bootstrap validation is set of validators which can be used on various form inputs to provide valuable and actionable feedback to users.


Basic example and usage

In order to turn on validation for a specific form control, add the mdbValidate directive to it.

The mdb-error and mdb-success components allow us to display validation messages under the form element.

Warning

For the validation messages to be displayed correctly, place them together with the form control and its label inside a div element with class md-form.

        
            
            <form [formGroup]="validatingForm">
              <div class="md-form">
                <input mdbInput mdbValidate type="text" id="form1" class="form-control" formControlName="required">
                <label for="form1">Required validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    
        
            
            import { FormGroup, FormControl, Validators } from '@angular/forms';
            import { Component } from '@angular/core';

            @Component({
              selector: 'validators-component-example',
              templateUrl: 'validators-example.html',
            })
            export class ValidatorsComponent {
              validatingForm: FormGroup;

              constructor() {
                this.validatingForm = new FormGroup({
                  required: new FormControl(null, Validators.required)
                });
              }

              get input() { return this.validatingForm.get('required'); }
            }
          
        
    

Reactive forms default validators

minLength Validator

minLength validation attribute is set to 3.

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="text" id="form2" class="form-control" formControlName="minLength">
              <label for="form2">minLength validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                minLength: new FormControl(null, [Validators.required, Validators.minLength(3)])
              });
            }

            get input() { return this.validatingForm.get('minLength'); }
          }
        
        
    

maxLength Validator

maxLength validation attribute is set to 5.

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="text" id="form3" class="form-control" formControlName="maxLength">
              <label for="form3">maxLength validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                maxLength: new FormControl(null, [Validators.required, Validators.maxLength(5)])
              });
            }

            get input() { return this.validatingForm.get('maxLength'); }
          }
        
        
    

Min value Validator

Min value is set to 10.

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="number" id="form4" class="form-control" formControlName="min">
              <label for="form4">min value validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                min: new FormControl(null, Validators.min(10))
              });
            }

            get input() { return this.validatingForm.get('min'); }
          }
        
        
    

Max value Validator

Max value is set to 10.

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="number" id="form5" class="form-control" formControlName="max">
              <label for="form5">max value validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormContorl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                max: new FormControl(null, Validators.max(10))
              });
            }

            get input() { return this.validatingForm.get('max'); }
          }
        
        
    

Email Validator

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="email" id="form8" class="form-control" formControlName="email">
              <label for="form8">Email validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                email: new FormControl(null, [Validators.required, Validators.email])
              });
            }

            get input() { return this.validatingForm.get('email'); }
          }
        
        
    

Pattern Validator

Pattern Validator should contain a RegEx. With it, the pattern is able to validate using regular expressions. In this example, RegEx allows us to put only English letters into the input?.

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="text" id="form7" class="form-control" formControlName="pattern">
              <label for="form7">only letters (pattern) validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                pattern: new FormControl(null, Validators.pattern(/A-Za-z/))
              });
            }

            get input() { return this.validatingForm.get('pattern'); }
          }
        
        
    

Required Validator

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="text" id="form1" class="form-control" formControlName="required">
              <label for="form1">Required validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                required: new FormControl(null, Validators.required)
              });
            }

            get input() { return this.validatingForm.get('required'); }
          }
        
        
    

Update on submit

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input
                mdbInput
                mdbValidate
                type="text"
                id="form1"
                class="form-control"
                formControlName="input"
              />
              <label for="form1">Required validator</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
            </div>
            <button type="submit" mdbBtn color="primary" (click)="onSubmit()">Submit form</button>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                input: new FormControl(null, Validators.required)
              }, { updateOn: 'submit' });
            }

            get input() { return this.validatingForm.get('input'); }

            onSubmit() {
              this.validatingForm.controls.input?.markAsTouched();
            }
          }
        
        
    

Update on blur

        
            
          <form [formGroup]="validatingForm">
            <div class="md-form">
              <input mdbInput mdbValidate type="text" id="form1" class="form-control" formControlName="onBlur">
              <label for="form1">Required validator</label>
              <mdb-error *ngIf="onBlur.invalid && (onBlur.dirty || onBlur.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="onBlur.valid && (onBlur.dirty || onBlur.touched)">Input valid</mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormGroup, FormControl, Validators } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'validators-component-example',
            templateUrl: 'validators-example.html',
          })
          export class ValidatorsComponent {
            validatingForm: FormGroup;

            constructor() {
              this.validatingForm = new FormGroup({
                onBlur: new FormControl(null, Validators.required)
              }, { updateOn: 'blur' });
            }

            get onBlur() { return this.validatingForm.get('onBlur'); }
          }
        
        
    

Template-driven forms default validators

minLength Validator

minLength validation attribute is set to 3.

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form2" class="form-control" [(ngModel)]="minLength" #input="ngModel" required minlength="3">
                <label for="form2">minLength validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

maxLength Validator

maxLength validation attribute is set to 5.

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form3" class="form-control" [(ngModel)]="maxLength" #input="ngModel" required maxlength="5">
                <label for="form3">maxLength validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Min value Validator

Min value is set to 10.

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="number" id="form4" class="form-control" [(ngModel)]="min" #input="ngModel" min="10">
                <label for="form4">min value validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Max value Validator

Max value is set to 10.

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="number" id="form5" class="form-control" [(ngModel)]="max" #input="ngModel" max="10">
                <label for="form5">max value validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Email Validator

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="email" id="form8" class="form-control" [(ngModel)]="email" #input="ngModel" required pattern="[^ @]*@[^ @]*">
                <label for="form8">Email validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Pattern Validator

Pattern Validator should contain RegEx. With it, the pattern is able to validate using regular expressions. In this example, RegEx allows us to put only English letters into the input?.

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form7" class="form-control" [(ngModel)]="pattern" #input="ngModel" required [pattern]="'[A-Za-z]*'">
                <label for="form7">only letters (pattern) validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Required Validator

        
            
            <form>
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form1" class="form-control" [(ngModel)]="required" #input="ngModel" required>
                <label for="form1">Required validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Update on submit

        
            
            <form [ngFormOptions]="{updateOn: 'submit'}">
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form1" class="form-control" [(ngModel)]="inputControl" #input="ngModel" required>
                <label for="form1">Required validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
              <button type="submit" mdbBtn color="primary" (click)="input?.control.markAsTouched()">Submit form</button>
            </form>
          
        
    

Update on blur

        
            
            <form [ngFormOptions]="{updateOn: 'blur'}">
              <div class="md-form">
                <input mdbInput mdbValidate name="input" type="text" id="form1" class="form-control" [(ngModel)]="blur" #input="ngModel" required>
                <label for="form1">Required validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    

Validating other components

You can use the mdbValidate directive to validate other form components as well.

        
            
              <!-- Material form contact -->
              <div class="row">
                <div class="col-md-6">
                  <mdb-card>
                    <mdb-card-header class="info-color text-center white-text py-4">
                      <h5><strong>Register</strong></h5>
                    </mdb-card-header>
                    <!-- Card content -->
                    <mdb-card-body class="px-lg-5 pt-0">
                      <!-- Form -->
                      <form [formGroup]="registerForm">
                        <!-- Name -->
                        <div class="md-form mt-3">
                          <input type="text" id="materialContactFormName" class="form-control" mdbInput mdbValidate
                            formControlName="nameInput" />
                          <label for="materialContactFormName">Name</label>
                          <mdb-error *ngIf="nameinput?.invalid && (nameinput?.dirty || nameinput?.touched)">Input invalid</mdb-error>
                          <mdb-success *ngIf="nameinput?.valid && (nameinput?.dirty || nameinput?.touched)">Input valid</mdb-success>
                        </div>
                        <!-- E-mail -->
                        <div class="md-form">
                          <input type="email" id="materialContactFormEmail" class="form-control" mdbInput mdbValidate
                            formControlName="emailInput" />
                          <label for="materialContactFormEmail">E-mail</label>
                          <mdb-error *ngIf="emailinput?.invalid && (emailinput?.dirty || emailinput?.touched)">Input invalid</mdb-error>
                          <mdb-success *ngIf="emailinput?.valid && (emailinput?.dirty || emailinput?.touched)">Input valid</mdb-success>
                        </div>
                        <!-- Subject -->
                        <div class="md-form">
                          <mdb-select [options]="optionsSelect" label="Eyes color" mdbValidate formControlName="select"
                            [allowClear]="true"></mdb-select>
                          <mdb-error *ngIf="select.invalid && (select.dirty || select.touched)">Input invalid</mdb-error>
                          <mdb-success *ngIf="select.valid && (select.dirty || select.touched)">Input valid</mdb-success>
                        </div>
                        <div class="md-form">
                          <input mdbValidate formControlName="autocomplete" type="text" class="completer-input form-control mdb-autocomplete mb-0"
                                [mdbAutoCompleter]="auto"
                                placeholder="Choose your color">
                          <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                            <mdb-option *ngFor="let option of results | async" [value]="option">
                              {{option}}
                            </mdb-option>
                          </mdb-auto-completer>
                          <mdb-error *ngIf="autocomplete.invalid && (autocomplete.dirty || autocomplete.touched)">Input invalid</mdb-error>
                          <mdb-success *ngIf="autocomplete.valid && (autocomplete.dirty || autocomplete.touched)">Input valid</mdb-success>
                        </div>
                        <div class="md-form">
                          <mdb-date-picker mdbValidate name="mydate" [options]="myDatePickerOptions" formControlName="datepicker"
                            placeholder="Birth date">
                            formControlName="datepicker"></mdb-date-picker>
                          <mdb-error *ngIf="datepicker.invalid && (datepicker.dirty || datepicker.touched)">Date invalid</mdb-error>
                          <mdb-success *ngIf="datepicker.valid && (datepicker.dirty || datepicker.touched)">Date valid</mdb-success>
                        </div>
                        <!-- Message -->
                        <div class="md-form">
                          <textarea type="text" id="materialContactFormMessage" class="form-control md-textarea" mdbInput mdbValidate
                            formControlName="address"></textarea>
                          <label for="materialContactFormMessage">Address</label>
                          <mdb-error *ngIf="address.invalid && (address.dirty || address.touched)">Input invalid</mdb-error>
                          <mdb-success *ngIf="address.valid && (address.dirty || address.touched)">Input valid</mdb-success>
                        </div>
                        <div class="md-form">
                          <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="materialInline1" name="radio" formControlName="radio"
                              value="pro">
                            <label class="form-check-label" for="materialInline1">Pro user</label>
                          </div>
                          <!-- Material inline 2 -->
                          <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="materialInline2" name="radio" formControlName="radio"
                              value="free">
                            <label class="form-check-label" for="materialInline2">Free user</label>
                          </div>
                          <mdb-error *ngIf="radio.invalid && (radio.dirty || radio.touched)">Please choose user role</mdb-error>
                          <mdb-success *ngIf="radio.valid && (radio.dirty || radio.touched)">User role valid</mdb-success>
                        </div>
                        <div class="md-form mb-5">
                          <mdb-checkbox mdbValidate formControlName="terms" value="agree">I agree to Terms Of Service</mdb-checkbox>
                          <mdb-error *ngIf="terms.invalid && (terms.dirty || terms.touched)">Please accept the terms</mdb-error>
                          <mdb-success *ngIf="terms.valid && (terms.dirty || terms.touched)">Terms accepted</mdb-success>
                        </div>
                        <!-- Send button -->
                        <button mdbBtn class="pt-5" color="info" outline="true" rounded="true" block="true" class="z-depth-0 my-4 waves-effect"
                          mdbWavesEffect type="submit">
                          Send
                        </button>
                      </form>
                      <!-- Form -->
                    </mdb-card-body>
                  </mdb-card>
                  <!-- Material form contact -->
                </div>
              </div>
            
        
    
        
            
              import { FormGroup, FormControl, Validators } from '@angular/forms';
              import { Component } from '@angular/core';
              import { Observable } from 'rxjs';
              import { startWith, map } from 'rxjs/operators';
              import { IMyOptions } from 'ng-uikit-pro-standard';

              @Component({
                selector: 'validators-component-example',
                templateUrl: 'validators-example.html',
              })
              export class ValidatorsComponent {
                results: Observable<string[]>;

                data: any = ['red', 'green', 'blue', 'cyan', 'magenta', 'yellow', 'black'];

                registerForm: FormGroup;

                optionsSelect = [
                  { value: 'Green', label: 'Green' },
                  { value: 'Blue', label: 'Blue' },
                  { value: 'Brown', label: 'Brown' },
                ];

                myDatePickerOptions: IMyOptions = {
                  // Your options
                };

                constructor() {
                  this.registerForm = new FormGroup({
                    nameInput: new FormControl(null, Validators.required),
                    emailInput: new FormControl(null, [Validators.required, Validators.email]),
                    select: new FormControl(null, Validators.required),
                    autocomplete: new FormControl(null, Validators.required),
                    datepicker: new FormControl(null, Validators.required),
                    address: new FormControl(null, Validators.required),
                    radio: new FormControl(null, Validators.required),
                    terms: new FormControl(null, Validators.requiredTrue)
                  });

                  this.results = this.registerForm.controls.autocomplete.valueChanges
                  .pipe(
                    startWith(''),
                    map((value: string) => this.filter(value))
                  );
                }

                filter(value: string): string[] {
                  const filterValue = value.toLowerCase();
                  return this.data.filter((item: any) => item.toLowerCase().includes(filterValue));
                }

                get nameInput() { return this.registerForm.get('nameInput'); }
                get emailInput() { return this.registerForm.get('emailInput'); }
                get select() { return this.registerForm.get('select'); }
                get autocomplete() { return this.registerForm.get('autocomplete'); }
                get datepicker() { return this.registerForm.get('datepicker'); }
                get address() { return this.registerForm.get('address'); }
                get radio() { return this.registerForm.get('radio'); }
                get terms() { return this.registerForm.get('terms'); }
              }
            
        
    

Resetting a validation status

        
            
            <!-- Login form -->
            <form [formGroup]="loginForm">
              <p class="h5 text-center mb-4">Sign in</p>
              <div class="md-form">
                <i class="fas fa-envelope prefix grey-text"></i>
                <input mdbInput mdbValidate type="text" formControlName="defaultFormEmail" id="defaultForm-email" class="form-control">
                <label for="defaultForm-email">Your email</label>
                <mdb-error *ngIf="defaultFormEmail.invalid && (defaultFormEmail.dirty || defaultFormEmail.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="defaultFormEmail.valid && (defaultFormEmail.dirty || defaultFormEmail.touched)">Input valid</mdb-success>
              </div>
              <div class="md-form">
                <i class="fas fa-lock prefix grey-text"></i>
                <input mdbInput mdbValidate type="password" formControlName="defaultFormPass" id="defaultForm-pass" class="form-control">
                <label for="defaultForm-pass">Your password</label>
                <mdb-error *ngIf="defaultFormPass.invalid && (defaultFormPass.dirty || defaultFormPass.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="defaultFormPass.valid && (defaultFormPass.dirty || defaultFormPass.touched)">Input valid</mdb-success>
              </div>
              <div class="text-center">
                <button type="submit" mdbBtn color="default" class="waves-light" mdbWavesEffect value="Login" (click)="submit(loginForm)">
              </div>
            </form>
            <!-- Login form -->
          
        
    
        
            
            import { Component } from '@angular/core';
            import { FormGroup, FormControl, Validators } from '@angular/forms';

            @Component({
              selector: 'validation-reset',
              templateUrl: './validation-reset.component.html',
              styleUrls: ['./validation-reset.component.scss'],
            })
            export class ValidationResetComponent {
              loginForm: FormGroup;

              constructor() {
                this.loginForm = new FormGroup({
                  defaultFormEmail: new FormControl(null, Validators.required);
                  defaultFormPass: new FormControl(null, [Validators.required, Validators.minLength(8)])
                });
              }

              get defaultFormEmail() { return this.loginForm.get('defaultFormEmail'); }
              get defaultFormPass() { return this.loginForm.get('defaultFormPass'); }

              submit(form: any) {
                form.reset();
              }
            }
          
        
    

Dynamic validation messages

In order to display validation messages under the validated element, you need to add the mdb-error and mdb-success components.

Sometimes one form control has several validators and it is necessary to display different validation messages depending on the user input?. The following example demonstrates how to do that:

        
            
            <form [formGroup]="validatingForm">
              <div class="md-form">
                <input mdbInput mdbValidate type="email" id="form8" class="form-control" formControlName="email">
                <label for="form8">Email validator</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)">
                  <span *ngIf="input?.errors.required">Email is required</span>
                  <span *ngIf="input?.errors.email">This email address is not valid</span>
                </mdb-error>
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    
        
            
            import { FormGroup, FormControl, Validators } from '@angular/forms';
            import { Component } from '@angular/core';

            @Component({
              selector: 'validators-component-example',
              templateUrl: 'validators-example.html',
            })
            export class ValidatorsComponent {
              validatingForm: FormGroup;

              constructor() {
                this.validatingForm = new FormGroup({
                  email: new FormControl(null, [Validators.required, Validators.email])
                });
              }

              get input() { return this.validatingForm.get('max'); }
            }
          
        
    

Angular Validation - API

In this section you will find informations about required modules and available inputs, outputs, methods and events of validation component.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

API Reference for MDB Angular Validation:
        
            
          import { InputsModule, InputUtilitiesModule, WavesModule, ButtonsModule } from 'ng-uikit-pro-standard';
          import { FormsModule, ReactiveFormsModule } from '@angular/forms';
        
        
    
        
            
          import { InputsModule, InputUtilitiesModule, WavesModule, ButtonsModule } from 'angular-bootstrap-md';
          import { FormsModule, ReactiveFormsModule } from '@angular/forms';
      
        
    

Components

MdbValidate

Selector: mdbValidate

Type: MdbValidateDirective

MdbError

Selector: mdb-error

Type: MdbErrorComponent

MdbSuccess

Selector: mdb-success

Type: MdbSuccessComponent


Inputs

mdbValidate

Name Type Default Description Example
validate boolean true Allow to toggle validation [validate]="false"
validateError boolean true Allow to toggle error validation [validateError]="false"
validateSuccess boolean true Allow to toggle success validation [validateSuccess]="false"

Angular Validation - examples & customization


File upload validation

        
            
            <form [formGroup]="validationForm">
              <div class="file-field md-form">
                <div mdbBtn color="primary" size="sm" class="waves-light" mdbWavesEffect>
                  <span>Choose file</span>
                  <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
                </div>
                <div class="file-path-wrapper">
                  <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()" formControlName="file">
                </div>
                <mdb-error *ngIf="file.invalid && (file.dirty || file.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="file.valid && (file.dirty || file.touched)">Input valid</mdb-success>
              </div>
            </form>
          
        
    
        
            
            import { FormGroup, FormControl, Validators } from '@angular/forms';
            import { Component } from '@angular/core';

            @Component({
              selector: 'validators-component-example',
              templateUrl: 'validators-example.html',
            })
            export class ValidatorsComponent {
              validationForm: FormGroup;
              formData: FormData;
              files: UploadFile[];
              uploadInput: EventEmitter<UploadInput>;
              humanizeBytes: Function;
              dragOver: boolean;

              constructor() {
                this.files = [];
                this.uploadInput = new EventEmitter<UploadInput>();
                this.humanizeBytes = humanizeBytes;

                this.validationForm = new FormGroup({
                  file: new FormControl('', Validators.required)
                });
              }

              showFiles() {
                let files = '';
                for (let i = 0; i < this.files.length; i ++) {
                  files += this.files[i].name;
                  if (!(this.files.length - 1 === i)) {
                    files += ',';
                  }
                }
                return files;
              }

              startUpload(): void {
                const event: UploadInput = {
                  type: 'uploadAll',
                  url: 'your-path-to-backend-endpoint',
                  method: 'POST',
                  data: { foo: 'bar' },
                };
                this.files = [];
                this.uploadInput.emit(event);
              }

              cancelUpload(id: string): void {
                this.uploadInput.emit({ type: 'cancel', id: id });
              }

              onUploadOutput(output: UploadOutput | any): void {
                if (output.type === 'allAddedToQueue') {
                } else if (output.type === 'addedToQueue') {
                  this.files.push(output.file); // add file to array when added
                } else if (output.type === 'uploading') {
                  // update current data in files array for uploading file
                  const index = this.files.findIndex(file => file.id === output.file.id);
                  this.files[index] = output.file;
                } else if (output.type === 'removed') {
                  // remove file from array when removed
                  this.files = this.files.filter((file: UploadFile) => file !== output.file);
                } else if (output.type === 'dragOver') {
                  this.dragOver = true;
                } else if (output.type === 'dragOut') {
                } else if (output.type === 'drop') {
                  this.dragOver = false;
                }
                this.file.setValue(this.showFiles());
              }

              get file() { return this.validationForm.get('file'); }
            }